﻿// -----------------------------------------------------------------------
// <copyright file="IdentifierStrategy.cs" company="MicroLite">
// Copyright 2012 - 2016 Project Contributors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// </copyright>
// -----------------------------------------------------------------------
namespace MicroLite.Mapping
{
    /// <summary>
    /// The supported strategies used to manage a database identifier column value.
    /// </summary>
    public enum IdentifierStrategy
    {
        /// <summary>
        /// The identifier value is generated by the database upon insert (for example Identity in MsSQL or AutoIncrement in SQLite, MySQL or PostgreSQL).
        /// </summary>
        DbGenerated = 0,

        /// <summary>
        /// The identifier value is assigned by user code prior to insert (either manually or via an IListener).
        /// </summary>
        Assigned = 1,

        /// <summary>
        /// The identifier value is generated by a database sequence upon insert.
        /// </summary>
        Sequence = 2
    }
}